#!/usr/local/bin/ruby
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
intext = File.open("taxonomy.dat", "r")
outtext = File.open("taxo.txt", "w")
parenthash = Hash.new()
namehash = Hash.new()
intext.each_line("//") do
  |line|
  line =~ /\nID\s+\:\s*([0-9]+)\s*\n/
  child_id = $1
  line =~ /\nPARENT ID\s+\:\s*([0-9]+)\s*\n/
  parent_id = $1
  parenthash[child_id] = parent_id
  line =~ /\nSCIENTIFIC NAME\s+\:\s*([^\n]+)\s*\n/
  scientific_name = $1
  namehash[child_id] = scientific_name
end
intext.close
intext = File.open("taxonomy.dat", "r")
intext.each_line("//") do
  |line|
  getline = line
  getline.sub!(/\/\//,"")
  outtext.puts(getline, "HIERARCHY")
  line =~ /\nID\s+\:\s*([0-9]+)\s*\n/
  id_name = $1
  (1..30).each do
    outtext.puts(namehash[id_name])
    id_name = parenthash[id_name]
    break if namehash[id_name].nil?
  end
  outtext.print("//")
end
exit 
