#!/usr/local/bin/perl
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
open(TAXO, "c\:\\ftp\\taxonomy.dat");
$/ = "//";
$line = " ";
while ($line ne "")
{
$line = <TAXO>;
$line =~ /\nID +\: *([0-9]+) *\n/;
$id_name = $1;
$line =~ /\nPARENT ID +\: *([0-9]+) *\n/;
$parent_id_name = $1;
$parenthash{$id_name} = $parent_id_name;
$line =~ /\nSCIENTIFIC NAME +\: *([^\n]+) *\n/;
$scientific_name = lc($1);
$namehash{$id_name} = $scientific_name;
$termhash{$scientific_name} = $id_name;
$line =~ /\nRANK *\: *([a-z]+) *\n/;
$rank = $1;
$rankhash{$id_name} = $rank;
}
close(TAXO);
open(TAXO, "c\:\\ftp\\infect.txt");
open(OUT, ">phylum.txt");
$/ = "\n";
$line = " ";
while ($line ne "")
{
$line = <TAXO>;
$scientific_name = lc($line);
$scientific_name =~ s/\n$//o;
my @darwin;
next unless (exists($termhash{$scientific_name}));
$id_name = $termhash{$scientific_name};
for(1..30)
{
push(@darwin, ucfirst($namehash{$id_name}));
if ($rankhash{$id_name} eq "phylum")
{
$term_name = $namehash{$id_name};
$phyla_count{$term_name}++;
last;
}
$id_name = $parenthash{$id_name};
}
@darwin = reverse(@darwin);
print OUT join(":", @darwin);
print OUT "\n";
}
while ((my $key, my $value) = each(%phyla_count))
{
if ($value > 0)
{
$value = "000" . $value;
$value = substr($value, -2, 2);
push(@count_array, "$value $key");
}
}
@count_array = reverse(sort(@count_array));
print join("\n",@count_array);
exit;
