#!/usr/local/bin/python
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
import re, string
in_file = open("c:/ftp/taxonomy.dat", "r")
parenthash = {}
namehash = {}
termhash = {}
rankhash = {}
phyla_count = {}
old_line = "\n"
for line in in_file:
  line_end = re.match(r'//',line)
  if line_end:
    line = old_line
    id_match = re.search(r'\nID +\: *([0-9]+) *\n', line)
    if id_match:
      id_name = id_match.group(1)
    parent_match = re.search(r'\nPARENT ID +\: *([0-9]+) *\n', line)
    if parent_match:
      parent_id_name = parent_match.group(1)
      parenthash[id_name] = parent_id_name
    science_match = re.search(r'\nSCIENTIFIC NAME +\: *([^\n]+) *\n', line)
    if science_match:
      scientific_name = science_match.group(1)
      scientific_name = string.lower(scientific_name)
      namehash[id_name] = scientific_name
      termhash[scientific_name] = id_name
    rank_match = re.search(r'\nRANK *\: *([a-z ]+[a-z]) *\n', line)
    if rank_match:
      rank = rank_match.group(1)
      rankhash[id_name] = rank
    old_line = "\n"
  else:
    old_line = old_line + line
in_file.close()
in_file = open("c:/ftp/infect.txt", "r")
out_file = open("phylum.txt", "w")
for line in in_file:
  scientific_name = string.lower(line)
  scientific_name = string.rstrip(scientific_name)
  darwin = []
  if not (termhash.has_key(scientific_name)):
    continue
  id_name = termhash[scientific_name]
  for iterations in range(30):
    if namehash.has_key(id_name):
      darwin.append(namehash[id_name])
    if rankhash.has_key(id_name):
      if (rankhash[id_name] == "phylum"):
        term_name = namehash[id_name]
        if phyla_count.has_key(term_name):
          phyla_count[term_name] = int(phyla_count[term_name]) + 1
        else:
          phyla_count[term_name] = 1
        break
      id_name = parenthash[id_name]
  darwin.sort()
  darwin.reverse()
  print>>out_file, ':'.join(darwin)
count_array = []
for key,value in phyla_count.iteritems():
  if int(value) > 0:
    value = "000" + str(value)
    value = value[-2:]
    count_array.append(value + " " + key)
count_array.sort()
count_array.reverse()
print '\n'.join(count_array)
exit

 
