#!/usr/local/bin/ruby
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
in_file = File.open("c:/ftp/taxonomy.dat", "r")
$/ = "//"
parenthash = {}
namehash = {}
termhash = {}
rankhash = {}
phyla_count = {}
in_file.each_line do
  |line|
  line =~ /\nID +\: *([0-9]+) *\n/;
  id_name = $1;
  line =~ /\nPARENT ID +\: *([0-9]+) *\n/
  parent_id_name = $1
  parenthash[id_name] = parent_id_name
  line =~ /\nSCIENTIFIC NAME +\: *([^\n]+) *\n/
  if $1
    scientific_name = $1.downcase
    namehash[id_name] = scientific_name
    termhash[scientific_name] = id_name
  end
  line =~ /\nRANK *\: *([a-z]+) *\n/
  if $1
    rank = $1;
    rankhash[id_name] = rank;
  end
end
in_file.close
in_file = File.open("c:/ftp/infect.txt", "r")
out_file = File.open("phylum.txt", "w")
$/ = "\n"
in_file.each_line do
  |line|
  scientific_name = line.downcase
  scientific_name.chomp!
  darwin = []
  next unless termhash.has_key? scientific_name
  id_name = termhash[scientific_name]
  (1..30).each do
    |n|
    darwin.push(namehash[id_name])
    if rankhash[id_name] == "phylum"
       term_name = namehash[id_name]
       phyla_count[term_name] = phyla_count[term_name].to_i + 1
       break
    end
    id_name = parenthash[id_name]
  end
  out_file.puts darwin.reverse.join(":")
end
count_array = []
phyla_count.each do
  |key,value|
  if value > 0
    value = "000" + value.to_s
    value = value.slice(-2, 2)
    count_array.push(value + " " + key)
  end
end
puts count_array.sort.reverse.join("\n")
exit

 
