#!/usr/local/bin/python
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
import anydbm, string, re
doubhash = anydbm.open('doub', 'n')
literalhash = anydbm.open('literal', 'n')
in_file = open('c:\\ftp\\neocl.xml', "r")
singular = re.compile('omas')
england = re.compile('tumou?rs?')
phrase = ""
for line in in_file:
  neoplasm_match = re.search(r'\"\> ?(.+) ?\<', line)
  if neoplasm_match:
    phrase = neoplasm_match.group(1)
    phrase = singular.sub("oma",phrase)
    phrase = england.sub("tumor",phrase)
    literalhash[phrase] = ""
  hoparray = phrase.split()
  hoparray.append(" ")
  for i in range(len(hoparray)-1):
     doublet = hoparray[i] + " " + hoparray[i + 1]
     if doubhash.has_key(doublet):
          continue
     doubhash_match = re.search(r'[a-z]+ [a-z]+', doublet)
     if doubhash_match:
         doubhash[doublet] = ""
doubhash.close()
literalhash.close()
exit
