#!/usr/local/bin/ruby
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
require 'dbm'
mesh_file = File.open('c:/ftp/neocl.xml', 'r')
doublethash = DBM.open('doub')
literalhash = DBM.open('literal')
hoparray = Array.new()
phrase = String.new()
mesh_file.each_line do
  |line|
  line =~ /\"\> ?(.+) ?\<\//
  phrase = $1
  phrase.sub!(/\b([a-z]+oma)s/,'\1') if phrase =~ /\b([a-z]+oma)s/
  phrase.sub!(/\b(tumou?r)s/,'\1') if phrase =~ /\b(tumou?r)s/
  literalhash[phrase] = ""
  if phrase =~ /[a-z]+ [a-z]+/
    hoparray = phrase.split
  else
    next
  end
  hoparray.push(" ")
  hoparray.each_index do
      |i|
      next if doublethash.has_key? "hoparray[i] $hoparray[i+1]"
      if hoparray[i+1] =~ /[a-z]/
        doublethash[hoparray[i] + " " + hoparray[i+1]] = ""
      end
  end
end
doublethash.close
literalhash.close
exit
