#!/usr/local/bin/perl
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
use Fcntl;
use SDBM_File;
tie %doubhash, "SDBM_File", 'doub', O_RD, 0644;
tie %literalhash, "SDBM_File", 'literal', O_RD, 0644;
open (TEXT, "c\:\\big\\cancer_gene_titles.txt")||die"cannot";
$line = " ";
$count = 0;
while ($line ne "")
{
$bigline = $line = <TEXT>;
$bigline =~ s/\n//;
$bigline =~ s/\b([a-z]+oma)s/$1/g;
$bigline =~ s/\b(tumo[u]?r)s/$1/g;
$englishline = "";
@hoparray = split(/ /,$bigline);
for ($i=0;$i<(scalar(@hoparray));$i++)
{
$doublet = "$hoparray[$i] $hoparray[$i+1]";
if (exists $doubhash{$doublet})
{
if ($englishline ne "")
{
$englishline = $englishline . " $hoparray[$i+1]";
}
else
{
$englishline = $doublet;
}
}
else
{
if ($englishline ne "")
{
$englishline =~ s/^the //o;
$englishline =~ s/ the$//o;
$englishline =~ s/^in //o;
$englishline =~ s/ in$//o;
$englishline =~ s/^of //o;
$englishline =~ s/ of$//o;
$englishline =~ s/^and //o;
$englishline =~ s/ and$//o;
$englishline =~ s/^with //o;
$englishline =~ s/ with$//o;
$englishline =~ s/^from //o;
$englishline =~ s/ from$//o;
$englishline =~ s/ a$//o;
$englishline =~ s/^a //o;
next if (exists $literalhash{$englishline});
next if (exists $newhash{$englishline});
next if ($englishline !~ / [a-z]+ /);
$count++;
print $count . " " . $englishline . "\n";
$newhash{$englishline} = "";
}
}
}
}
untie %doubhash;
untie %literalhash;
exit;
