#!/usr/local/bin/python
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
import anydbm, string, re
doubhash = anydbm.open('doub')
literalhash = anydbm.open('literal')
newhash = {}
in_file = open('c:\\big\\cancer_gene_titles.txt', 'r')
line = " "
count = 0
singular = re.compile('omas')
england = re.compile('tumou?rs?')
for line in in_file:
   bigline = line.rstrip(" \n")
   bigline = singular.sub("oma", bigline)
   bigline = england.sub("tumor", bigline)
   englishline = ""
   hoparray = bigline.split()
   hoparray.append(" ")
   for i in range(len(hoparray) - 1):
     doublet = hoparray[i] + " " + hoparray[i + 1]
     if doubhash.has_key(doublet):
       if (englishline != ""):
         englishline = englishline + " " + hoparray[i + 1]
       else:
         englishline = doublet
     else:
       if englishline != "":
         englishline = englishline.strip()
         englishline = re.sub(r'^the ', "", englishline)
         englishline = re.sub(r'^in ', "", englishline)
         englishline = re.sub(r'^of ', "", englishline)
         englishline = re.sub(r'^and ', "", englishline)
         englishline = re.sub(r'^with ', "", englishline)
         englishline = re.sub(r'^from ', "", englishline)
         englishline = re.sub(r'^ a', "", englishline)
         englishline = re.sub(r' the$', "", englishline)
         englishline = re.sub(r' in$', "", englishline)
         englishline = re.sub(r' of$', "", englishline)
         englishline = re.sub(r' and$', "", englishline)
         englishline = re.sub(r' with$', "", englishline)
         englishline = re.sub(r' from$', "", englishline)
         englishline = re.sub(r' a$', "", englishline)
         if literalhash.has_key(englishline):
           continue
         if newhash.has_key(englishline):
           continue
         phrase_match = re.search(r' [a-z]+ ', englishline)
         if phrase_match:
           count = count + 1
           print str(count) + " " + englishline
           newhash[englishline] = ""
doubhash.close()
literalhash.close()
exit 
