#!/usr/local/bin/ruby
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
require 'dbm'
in_file = File.open('c:/big/cancer_gene_titles.txt', 'r')
doublethash = DBM.open('doub')
literalhash = DBM.open('literal')
newhash = Hash.new()
hoparray = Array.new()
phrase = String.new()
count = 0
in_file.each_line do
  |line|
  line.chomp!
  line.sub!(/\b([a-z]+oma)s/,'\1') if line =~ /\b([a-z]+oma)s/
  line.sub!(/\b(tumou?r)s/,'\1') if line =~ /\b(tumou?r)s/
  englishline = String.new()
  hoparray = line.split
  hoparray.push(" ")
  hoparray.each_index do
      |i|
      next unless hoparray[i+1]
      if doublethash.has_key? hoparray[i] + " " + hoparray[i+1]
        if englishline =~ /[a-z]/
          englishline = englishline + " " + hoparray[i+1]
        else
          englishline = hoparray[i] + " " + hoparray[i+1]
        end
      else
        if englishline
          englishline.strip!
          englishline.sub!(/^the /, "") if englishline =~ /^the /
          englishline.sub!(/ the$/, "") if englishline =~ / the$/
          englishline.sub!(/^in /, "") if englishline =~ /^in /
          englishline.sub!(/ in$/, "") if englishline =~ / in$/
          englishline.sub!(/^of /, "") if englishline =~ /^of /
          englishline.sub!(/ of$/, "") if englishline =~ / of$/
          englishline.sub!(/^and /, "") if englishline =~ /^and /
          englishline.sub!(/ and$/, "") if englishline =~ / and$/
          englishline.sub!(/^with /, "") if englishline =~ /^with /
          englishline.sub!(/ with$/, "") if englishline =~ / with$/
          englishline.sub!(/^from /, "") if englishline =~ /^from /
          englishline.sub!(/ from$/, "") if englishline =~ / from$/
          englishline.sub!(/^a /, "") if englishline =~ /^a /
          englishline.sub!(/ a$/, "") if englishline =~ / a$/
          next if literalhash.has_key? englishline
          next if newhash.has_key? englishline
          next if englishline !~ / [a-z]+ /
          count = count + 1
          puts count.to_s + " " + englishline
          newhash[englishline] = ""
        end
      end
  end
end
in_file.close
doublethash.close
literalhash.close
exit


 
