#!/usr/local/bin/ruby
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
vocab_in = File.open("c:/ftp/neocl.xml", "r")
doub_hash = {}
vocab_in.each_line do
  |line|
  next if (line !~ /C[0-9]{7}/)
  line =~ /\"\> ?(.+) ?\<\//
  phrase = $1
  doub_hash[phrase] = ""
end
vocab_in.close
candidate_file = File.open("c:/ftp/neocl.lst", "r")
out_file = File.open("new.out", "w")
candidate_file.each_line do
  |line|
  line.sub!(/\n/,"")
  next if (line == "")
  if doub_hash.has_key? line
    puts line + " already exists"
  else
    out_file.puts line
  end
end
exit 
