#!/usr/local/bin/perl
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
open (STDOUT, ">neoself")||die"Cannot";
my ($text, $lastname, $name, $count);
use XML::Parser;
my $parser = XML::Parser->new( Handlers => {
Start => \&handle_elem_start,
End => \&handle_elem_end,
Char => \&handle_char_data,
});
$file = "neocl.xml";
$parser -> parsefile($file);
sub handle_elem_start
{
($expat, $name, %atts) = @_;
if (exists $atts{"nci-code"})
{
$code = $atts{"nci-code"};
}
else
{
$lastname = $name . "\>" . $lastname;
}
}
sub handle_elem_end
{
($expat, $name) = @_;
if ($name eq "name")
{
$count++;
$text =~ s/\n//g;
print $count . "\|" . $text . "\|" . $code . "\|" . $lastname . "\n";
$text = "";
}
$lastname =~ s/${name}\>//g;
}
sub handle_char_data
{
($expat, $characters) = @_;
$text = $text . $characters;
}
exit;
