#!/usr/local/bin/ruby
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
require 'mathn'
data_in = File.open("c:/ftp/pop_data.txt", "r")
data_out = File.open("pop_data.out", "w")
age_array = []
crude_dict = {}
total_age = 0
data_in.each_line do
  |line|
  line.chomp!
  age_array = line.split(/\,/)
  if (age_array[2])
    crude_rate =  (age_array[1].to_i / age_array[2].to_i).to_f *  100000
    crude_dict[age_array[0]] = crude_rate
    total_age = total_age + age_array[3].to_i
  end
end
data_in.close()
data_in = File.open("c:/ftp/pop_data.txt")
total_rate = 0;
data_in.each_line do
  |line|
  line.chomp!
  age_array = line.split(/\,/)
  if (age_array[2])
    weight =  (age_array[3].to_i / total_age).to_f
    age_rate = weight * crude_dict[age_array[0]]
    total_rate = total_rate + age_rate
    data_out.printf("%-3.3d %-6.6d %-8.8d %-10.04f %-10.10d %-2.04f %-6.03f\n",
    age_array[0], age_array[1], age_array[2], crude_dict[age_array[0]],
    age_array[3], weight, age_rate)
  end
end
data_out.puts "\nThe age-adjusted population cancer rate is " + total_rate.to_s
data_out.puts  "The total population is " + total_age.to_s
exit 
