#!/usr/local/bin/python
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
import re, string
data_in = open("c:/ftp/pop_data.txt", "r")
data_out = open("pop_data.out", "w")
age_array = []
crude_dict = {}
total_age = 0
for line in data_in:
  line = string.rstrip(line)
  age_array = re.split(r',', line)
  if (age_array[2]):
    crude_rate =  (float(age_array[1]) / float(age_array[2])) *  100000
    crude_dict[age_array[0]] = crude_rate
    total_age = total_age + int(age_array[3])
data_in.close()
data_in = open("c:/ftp/pop_data.txt")
total_rate = 0;
for line in data_in:
  line = string.rstrip(line)
  age_array = re.split(r',', line)
  if (age_array[2]):
    weight =  (float(age_array[3]) / total_age)
    age_rate = weight * float(crude_dict[age_array[0]])
    total_rate = total_rate + age_rate
    print_format = "%-3.3d %-6.6d %-8.8d %-10.04f %-10.10d %-2.04f %-6.03f"
    print>>data_out, print_format % (int(age_array[0]), int(age_array[1]),
 int(age_array[2]), float(crude_dict[age_array[0]]), int(age_array[3]),
 float(weight), float(age_rate))
print>>data_out, "\nThe age-adjusted population cancer rate is " + str(total_rate)
print>>data_out, "The total population is " + str(total_age)
exit


