#!/usr/local/bin/ruby
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
icd_string = IO.read("c:/ftp/each10.txt")
linearray = icd_string.split(/\n(?= *[A-Z][0-9\.]{1,5})/)
dictionary = {}
counter = Hash.new(0)
codearray = []
results_array = []
linearray.each do
  |thing|
  if (thing =~ /^ *([A-Z][0-9\.]{1,5}) ?/)
    code = $1
    term = $'
    term.sub!(/[^a-zA-Z ]/,"")
    term.sub!(/[ ]+$/,"")
    code.sub!(/\./,"")
    dictionary[code] = term
  end
end
mort_txt = File.open("c:/big/Mort99us.dat", "r")
mort_txt.each_line do
  |line|
  codesection = line.slice(161,140)
  codesection.sub!(/ *$/, "")
  codearray = codesection.split(/ +/)
  codearray.each do
    |code|
    code =~ /[A-Z][0-9]+/
    code = $&
    if dictionary.has_key?(code)
      counter[code] = counter[code] + 1
    end
  end
end
mort_txt.close
out_mort = File.open("cdc.out", "w")
counter.each_pair do
   |key, value|
   value = value.to_s
   value = "000000" + value
   value = value.slice(-6,6)
   results_array.push(value + " " + key + " " + dictionary[key])
end
out_mort.puts results_array.sort.reverse.join("\n")
exit

 
