#!/usr/local/bin/perl
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
open(TEXT, "neocl.xml");
$line = " ";
while ($line ne "")
{
$line = <TEXT>;
next if ($line !~ /\"(C[0-9]{7})\"/);
$line =~ /\"(C[0-9]{7})\"/;
$code = $1;
$line =~ /\"\> ?(.+) ?\<\//;
$phrase = $1;
if ($phrase =~ /[a-z]/)
{
$literalhash{$phrase} = $code;
}
}
$phrase = "";
close TEXT;
print "Neoplasm code hash has been created. Autocoding will start
now\n";
open(ABSFILE, "tumorabs.txt")||die"cannot";
open(OUTFILE, ">tumorab2.out")||die"cannot";
$line = " ";
while($line ne "")
{
$line = <ABSFILE>;
$sentence = $line;
$sentence =~ s/\n//o;
$sentence =~ s/omas/oma/g;
$sentence =~ s/tumo[u]?rs/tumor/g;
print OUTFILE "\nTitle..." . ucfirst($sentence) . "." . "\n";
@sentence_array = split(/ /,$sentence);
$cycles = scalar(@sentence_array);
for($n=0;$n<$cycles;$n++)
{
for($i=0;$i<scalar(@sentence_array);$i++)
{
@part_array = @sentence_array[0..$i];
$phrase = join(" ", @part_array);
if (exists($literalhash{$phrase}))
{
print OUTFILE "Autocoded tumor..." . ucfirst($phrase) . " " . $literalhash{$phrase} . "\n";
}
}
shift(@sentence_array);
}
}
exit;
