#!/usr/local/bin/python
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
import re
text = open("neocl.xml", "r")
literalhash = {}
codematch = re.compile('\"(C\d{7})\"')
phrasematch = re.compile('\"\> ?(.+) ?\<\/')
for line in text:
    m= codematch.search(line)
    if m:
      code = m.group(1)
    else:
      continue
    x = phrasematch.search(line)
    if x:
      phrase = x.group(1)
    else:
      continue
    literalhash[phrase] = code
text.close()
print "Neoplasm code hash has been created.  Autocoding will start now"
absfile = open("tumorabs.txt", "r")
outfile = open("tumorpy.out", "w")
singular = re.compile('omas')
england = re.compile('tumo[u]?rs')
for line in absfile:
    sentence = line
    sentence = singular.sub("oma",sentence)
    sentence = england.sub("tumor",sentence)
    sentence = sentence.rstrip()
    print>>outfile,"\nAbstract title..." + sentence + "."
    sentence_array = sentence.split(" ")
    length = len(sentence_array)
    for i in range(length):
      for place_length in range(len(sentence_array)):
          last_element = place_length + 1
          phrase = ' '.join(sentence_array[0:last_element])
          if literalhash.has_key(phrase):
             print>>outfile,"Neoplasm term..." + phrase + " " + literalhash[phrase]
      sentence_array.pop(0)
exit
