#!/usr/local/bin/ruby
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
text = File.open("neocl.xml", "r")
literalhash = Hash.new
text.each do
    |line|
    next if (line !~ /\"(C[0-9]{7})\"/)
    line =~ /\"(C[0-9]{7})\"/
    code = $1;
    line =~ /\"\> ?(.+) ?\<\//
    phrase = $1;
    if (phrase =~ /[a-z]/)
        literalhash[phrase] = code
        #puts phrase
    end
end
text.close
puts "Neoplasm code hash has been created.  Autocoding will start now"
absfile = File.open("tumorabs.txt", "r")
outfile = File.open("tumorabs.out", "w")
absfile.each do
   |sentence|
   sentence.chomp!
   sentence.gsub!(/omas/, "oma")
   sentence.gsub!(/tumo[u]?rs/, "tumor")
   outfile.puts "\nAbstract title..." + sentence.capitalize + "."
   sentence_array = sentence.split
   length = sentence_array.size
   length.times do
      (1..sentence_array.size).each do
         |place_length|
         phrase = sentence_array.slice(0,place_length).join(" ")
         if literalhash.has_key?(phrase)
            outfile.puts "Neoplasm term..." + phrase.capitalize + " " + literalhash[phrase]
         end
      end
   sentence_array.shift
   end
end
exit 
