#!/usr/local/bin/ruby
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
require 'mathn'
in_file = File.open("c:/big/Mort99us.dat")
count = 0
whitecount = 0
blackcount = 0
whiteemph = 0
blackemph = 0
in_file.each_line do
  |line|
  count = count + 1
  codesection = line.slice(161,140)
  race = line.slice(59,2)
  whitecount = whitecount + 1 if race.eql?("01")
  blackcount = blackcount + 1 if race.eql?("02")
  if (codesection =~ /J43/)
    whiteemph = whiteemph + 1 if race.eql?("01")
    blackemph = blackemph + 1 if race.eql?("02")
  end
end
in_file.close
whiteempfrac = (100 * ((whiteemph / whitecount).to_f)).to_s
blackempfrac = (100 * ((blackemph / blackcount).to_f)).to_s
puts "Total records in file is " + count.to_s
puts "Total African-Americans in file is " + blackcount.to_s
puts "Total Whites in file is " + whitecount.to_s
puts "Total African-Americans with emphysema is " + blackemph.to_s
puts "Total Whites with emphysema is " + whiteemph.to_s
puts "Percent African-Americans with emphysema is " + blackempfrac.slice(0,4)
puts "Percent Whites with emphysema is " + whiteempfrac.slice(0,4)
exit 
