#!/usr/local/bin/perl
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
open (ICD, "c\:\\ftp\\icdo3\.txt");
$line = " ";
$black_count = 0;
$white_count = 0;
while ($line ne "")
{
$line = <ICD>;
if ($line =~ /([0-9]{4})\/([0-9]{1}) +/o)
{
$code = $1 . $2;
$term = $';
$term =~ s/ *\n//o;
$dictionary{$code} = $term;
}
}
close ICD;
opendir(FTPDIR, "c\:\\big\\seer2006") || die ("Unable to open directory");
@files = readdir(FTPDIR);
closedir(FTPDIR);
chdir("c\:\\big\\seer2006");
foreach $datafile (@files)
{
open (TEXT, $datafile);
$line = " ";
while ($line ne "")
{
$line = <TEXT>;
$code = substr($line, 47, 5);
$code2 = substr($line, 52, 5);
if (exists($dictionary{$code2}))
{
$code = $code2;
}
if (exists($dictionary{$code}))
{
$code_count{$code}++;
if (substr($line,19,2) eq "02") #02 means black
{
$black_count++;
$bl_count{$code}++;
}
if (substr($line,19,2) eq "01") #01 means white
{
$white_count++;
$wh_count{$code}++;
}
}
}
close(TEXT);
}
print "\nNumber of black persons with cancer is $black_count\n";
print "Number of white persons with cancer is $white_count\n";
open(OUT, ">c\:\\ftp\\seer_out.txt");
while((my $key, my $value) = each (%bl_count))
{
if ($bl_count{$key} > 5)
{
if ($wh_count{$key} > 5)
{
$whfract = ($wh_count{$key} / $white_count) / ($bl_count{$key} / $black_count);
printf OUT ("%05.2f %-6.6d %-55.55s\n", $whfract, $code_count{$key}, $dictionary{$key});
}
}
}
exit;
