#!/usr/local/bin/python
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
import sys, os, re, string
icd_in = open("c:/ftp/icdo3.txt", "r")
dictionary = {}
bl_count = {}
wh_count = {}
code_count = {}
black_count = 0
white_count = 0
for line in icd_in:
  code_has = re.search(r'([0-9]{4})\/([0-9]{1}) +(.+)', line)
  if code_has:
    code = code_has.group(1) + code_has.group(2)
    term = code_has.group(3)
    term = string.rstrip(term)
    dictionary[code] = term
    bl_count[code] = 0
    wh_count[code] = 0
    code_count[code] = 0
icd_in.close
filelist = os.listdir("c:/big/seer2006")
os.chdir("c:/big/seer2006")
for file in filelist:
  infile = open(file,'r')
  for line in infile:
    code = line[47:52]
    code2 = line[52:57]
    if dictionary.has_key(code2):
      code = code2
    if dictionary.has_key(code):
      code_count[code] = code_count[code] + 1
      if (line[19:21] == "02"):              #02 means black
        black_count = black_count + 1
        bl_count[code] = bl_count[code] + 1
      if (line[19:21] == "01"):
        white_count = white_count + 1
        wh_count[code] = wh_count[code] + 1
  infile.close()
os.chdir("c:/ftp/py")
print "Number of black persons with cancer is " + str(black_count)
print "Number of white persons with cancer is " + str(white_count)
print
seer_out = open("c:/ftp/seer_out.txt", "w")
for key,value in bl_count.iteritems():
  if (bl_count[key] > 5):
     if (wh_count[key] > 5):
       wbfract = (float(wh_count[key]) / float(white_count)) / (float(bl_count[key]) / float(black_count))
       print>>seer_out, "%05.2f %-6.6d %-55.55s" % (wbfract, code_count[key], dictionary[key])
exit 
