#!/usr/local/bin/perl
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
open (ICD, "c\:\\ftp\\icdo3\.txt");
$line = " ";
$black_count = 0;
$hisp_count = 0;
while ($line ne "")
{
$line = <ICD>;
if ($line =~ /([0-9]{4})\/([0-9]{1}) +/o)
{
$code = $1 . $2;
$term = $';
$term =~ s/ *\n//o;
$dictionary{$code} = $term;
}
}
close ICD;
opendir(FTPDIR, "c\:\\big\\seer2006") || die ("Unable to open directory");
@files = readdir(FTPDIR);
closedir(FTPDIR);
chdir("c\:\\big\\seer2006");
foreach $datafile (@files)
{
open (TEXT, $datafile);
$line = " ";
while ($line ne "")
{
$line = <TEXT>;
$code = substr($line, 47, 5);
$code2 = substr($line, 52, 5);
if (exists($dictionary{$code2}))
{
$code = $code2;
}
if (exists($dictionary{$code}))
{
if (substr($line,21,1) eq "0") #0 means non-hispanic
{
next unless (substr($line,19,2) eq "02");
$black_count++;
next if ($code !~ /90[678]/);
$bl_count{$code}++;
}
else
{
next if (substr($line,19,2) ne "01");
$hisp_count++;
next if ($code !~ /90[678]/);
$hi_count{$code}++;
}
$germ_count++;
}
}
close(TEXT);
}
print "\nNumber of black persons with cancer is $black_count\n";
print "Number of hispanic persons with cancer is $hisp_count\n";
print "Total number of germ cell tumor records is $germ_count\n\n";
while((my $key, my $value) = each (%bl_count))
{
if ($bl_count{$key} > 5)
{
if ($hi_count{$key} > 5)
{
$hbfract = ($hi_count{$key} / $hisp_count) / ($bl_count{$key} / $black_count);
printf ("%-3.02f %-35.35s\n", $hbfract, $dictionary{$key});
}
}
}
exit;
