#!/usr/local/bin/python
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
import sys, os, re, string
icd_in = open("c:/ftp/icdo3.txt", "r")
dictionary = {}
bl_count = {}
hi_count = {}
black_count = 0
hisp_count = 0
germ_count = 0
for line in icd_in:
  code_has = re.search(r'([0-9]{4})\/([0-9]{1}) +(.+)', line)
  if code_has:
    code = code_has.group(1) + code_has.group(2)
    term = code_has.group(3)
    term = string.rstrip(term)
    dictionary[code] = term
    bl_count[code] = 0
    hi_count[code] = 0
icd_in.close
filelist = os.listdir("c:/big/seer2006")
os.chdir("c:/big/seer2006")
for file in filelist:
  infile = open(file,'r')
  for line in infile:
    code = line[47:52]
    code2 = line[52:57]
    if dictionary.has_key(code2):
      code = code2
    hispanic_entry = re.match(r'[0-9]', line[21])  #must have a hispanic entry
    if not hispanic_entry:
      continue
    race_entry = re.match(r'[012]', line[19]) #must have a race entry
    if not race_entry:
      continue
    if dictionary.has_key(code):
      if (line[21] == "0"):                    #0 means non-hispanic
        if not (line[19:21] == "02"):              #01 means white
          continue
        black_count = black_count + 1
        germ_code_match = re.match(r'90[678]', code)
        if not germ_code_match:
          continue
        bl_count[code] = bl_count[code] + 1
      else:
        if not (line[19:21] == "01"):
          continue
        hisp_count = hisp_count + 1
        germ_code_match = re.match(r'90[678]', code)
        if not germ_code_match:
          continue
        hi_count[code] = hi_count[code] + 1
      germ_count = germ_count + 1
  infile.close()
os.chdir("c:/ftp/py")
print "Number of black persons with cancer is " + str(black_count)
print "Number of hispanic persons with cancer is " + str(hisp_count)
print "Total number of germ cell tumor records is " + str(germ_count)
print
for key,value in bl_count.iteritems():
  if (bl_count[key] > 5):
     if (hi_count[key] > 5):
       hbfract = (float(hi_count[key]) / float(hisp_count)) / (float(bl_count[key]) / float(black_count))
       print "%-3.02f %-35.35s" % (hbfract, dictionary[key])
exit 
