#!/usr/local/bin/ruby
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
require 'mathn'
icd_in = File.open("c:/ftp/icdo3.txt", "r")
dictionary = {}
bl_count = Hash.new(0)
hi_count = Hash.new(0)
black_count = 0
hisp_count = 0
germ_count = 0
icd_in.each_line do
  |line|
  if line =~ /([0-9]{4})\/([0-9]{1}) +/
    code = $1 + $2
    term = $'
    term = term.sub(/ *\n/, "") if term =~ / *\n/
    dictionary[code] = term
  end
end
icd_in.close
filelist = Dir.glob("c:/big/seer2006/*.TXT")
filelist.each do
 |filepathname|
 seer_in = File.open(filepathname)
 seer_in.each_line do
   |line|
   code = line.slice(47, 5)
   code2 = line.slice(52, 5)
   if dictionary.has_key?(code2)
     code = code2
   end
   if dictionary.has_key?(code)
     if line.slice(21,1).eql?("0")  #0 means non-hispanic
       next unless line.slice(19,2).eql?("02")   #01 means white
       black_count = black_count + 1
       next if code !~ /90[678]/
       bl_count[code] = bl_count[code] + 1
     else
       next unless line.slice(19,2).eql?("01")
       hisp_count = hisp_count + 1
       next if code !~ /90[678]/
       hi_count[code] = hi_count[code] + 1
     end
     germ_count = germ_count + 1
   end
 end
 seer_in.close
end
puts "Number of black persons with cancer is " + black_count.to_s
puts "Number of hispanic persons with cancer is " + hisp_count.to_s
puts "Total number of germ cell tumor records is " + germ_count.to_s
puts
bl_count.each_pair do
  |key, value|
  if bl_count[key] > 5
     if hi_count[key] > 5
       hbfract = (hi_count[key].to_f / hisp_count.to_f) / (bl_count[key].to_f / black_count.to_f)
       printf "%-3.02f %-35.35s\n", hbfract, dictionary[key]
     end
  end
end
exit 
