#!/usr/local/bin/perl
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
open (STATE, "cdc_states.txt"); #maps CDC state number
$line = " "; #to the state abbreviation
while ($line ne "")
{
$line = <STATE>;
$line =~ /^[0-9]{2}/;
$state_code = $&;
$line =~ / +([A-Z]{2}) *$/;
$state_abb = $1;
$statehash{$state_code} = $state_abb;
}
close STATE;
open (ICD, "c\:\\big\\Mort99us.dat"); #the CDC mortality file
$line = " ";
while ($line ne "")
{
$line = <ICD>;
$codesection = substr($line,161,140);
$code = substr($line,20,2);
$state = $statehash{$code};
$state_total{$state}++;
$codesection =~ s/ +$//;
$eager = scalar(split(" ",$codesection));
$state_eager{$state} = $state_eager{$state} + $eager;
}
while ((my $key, my $value) = each(%state_total))
{
$goodness = substr(($state_eager{$key} / $value),0,5);
push(@list_array, "$goodness $key");
}
print join("\n", (sort(@list_array)));
exit;
