#!/usr/local/bin/python
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
import re, string
state_file = open("c:\\ftp\\cdc_states.txt", "r")
state_hash = {}
state_eager = {}
state_total = {}
list_array = []
for line in state_file:
  codematch = re.match(r'([0-9]{2})', line)
  if codematch:
    state_code = codematch.group(1)
  statematch = re.search(r' +([A-Z]{2}) *$', line)
  if statematch:
    state_abb = statematch.group(1)
  state_hash[state_code] = state_abb
  state_total[state_abb] = 0
  state_eager[state_abb] = 0
state_file.close()
cdc_file = open("c:\\big\\Mort99us.dat", "r")
for line in cdc_file:
  codesection = line[161:300]
  code = line[20:22]
  state = state_hash[code]
  state_total[state] = state_total[state] + 1
  codesection = re.sub(r' +$', "", codesection)
  eager = re.split(r' +', codesection)
  eager = len(eager)
  state_eager[state] = state_eager[state] + eager
for key in state_total.keys():
  goodness = str(float(state_eager[key]) / state_total[key])
  goodness = goodness[0:5]
  list_array.append(goodness + " " + key)
list_array = sorted(list_array)
for item in list_array:
  print item
exit 
