#!/usr/local/bin/ruby
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
require 'mathn'
state_file = File.open("c:/ftp/cdc_states.txt")
state_hash = {}
state_eager = {}
state_total = {}
list_array = []
state_file.each_line do
  |line|
  line =~ /^[0-9]{2}/
  state_code = $&;
  line =~ / +([A-Z]{2}) *$/
  state_abb = $1;
  state_hash[state_code] = state_abb
end
state_file.close
cdc_file = File.open("c:/big/Mort99us.dat")
cdc_file.each_line do
  |line|
  codesection = line.slice(161,140)
  code = line.slice(20,2)
  state = state_hash[code]
  state_total[state] = state_total[state].to_i + 1
  codesection = codesection.sub(/ +$/, "")
  eager = codesection.split(" ").length
  state_eager[state] = state_eager[state].to_i + eager
end
state_total.each do
  |key, value|
  goodness = (state_eager[key] / value).to_f.to_s.slice(0,5)
  list_array.push(goodness + " " + key)
end
puts list_array.sort.join("\n")
exit

 
