#!/usr/local/bin/ruby
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
stat_in = File.open("c:/ftp/cdc_states.txt")
statehash = {}
state_tally = Hash.new(0)
stat_in.each_line do
  |line|
  line =~ /^[0-9]{2}/
  state_code = $&
  line =~ / +([A-Z]{2}) *$/;
  state_abb = $1;
  statehash[state_code] = state_abb
end
stat_in.close
mort_in = File.open("c:/big/Mort99us.dat")
mort_in.each_line do
  |line|
  state = 0
  codesection = line.slice(161,140)
  if (codesection =~ /B38/)
    code = line.slice(20,2)
    state = statehash[code]
    state_tally[state] = state_tally[state] + 1
  end
end
mort_in.close
state_tally.each_pair {|key,value| puts key + " " + value.to_s}
exit 
