#!/usr/local/bin/perl
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
use Image::Magick;
$north = 49;
$south = 25;
$west = 125;
$east = 66;
open(TEXT, "c\:\\ftp\\loc_states.txt");
$line = " ";
while ($line ne "")
{
$line = <TEXT>;
$line =~ /^([A-Z]{2})\,([0-9\.]+)\,\-?([\.0-9]+) *$/;
$state = $1;
$latitude = $2;
$longitude = $3;
$lathash{$state} = $latitude;
$lonhash{$state} = $longitude;
}
close(TEXT);
open(TEXT, "c\:\\ftp\\state_count.txt");
$line = " ";
while ($line ne "")
{
$line = <TEXT>;
$line =~ / /;
$state_abb = $`;
$state_value = $';
$sizehash{$state_abb} = $state_value;
}
my $imgl = Image::Magick->new;
$imgl -> ReadImage("c\:\\ftp\\us.gif");
$width = $imgl -> Get('columns');
$height = $imgl -> Get('rows');
while ((my $key, my $value) = each(%lathash))
{
$state = $key;
$latitude = $value;
$longitude = $lonhash{$key};
$offset_y = int((($north - $latitude) / ($north - $south)) * $height);
$offset_x = int((($west - $longitude) / ($west - $east)) * $width);
if (exists($sizehash{$key}))
{
$radius = $offset_x + (2 * $sizehash{$key});
}
else #for the states with no cases of coccidioidomycosis
{
$radius = $offset_x + 0;
}
$imgl -> Draw (
stroke => "red",
primitive => "circle",
points => "${offset_x}, ${offset_y}, ${radius}, ${offset_y}");
}
$imgl -> write ("gif:cocc_pl.gif");
exit;
