#!/usr/local/bin/python
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
import sys
import Image, ImageDraw
import re
lathash = {}
lonhash = {}
sizehash = {}
north = 49
south = 25
west = 125
east = 66
infile = open ("loc_states.txt", "r")
for line in infile:
   match_tuple = re.match(r'^([A-Z]{2})\,([0-9\.]+)\,\-?([\.0-9]+) *$',line)
   state = match_tuple.group(1)
   latitude = float(match_tuple.group(2))
   longitude = float(match_tuple.group(3))
   lathash[state] = latitude
   lonhash[state] = longitude
   sizehash[state] = 0
infile.close()
infile = open("c:/ftp/state_count.txt", "r")
for line in infile:
    space_match = re.match(r'([A-Z]+) ([0-9]+)$', line)
    if space_match:
      state_abb = space_match.group(1)
      state_value = space_match.group(2)
      sizehash[state_abb] = state_value
infile.close()
im = Image.open("c:/ftp/us.jpg", "r")
print im.mode
[width, height] = im.size
draw = ImageDraw.Draw(im)
for state, latitude in lathash.iteritems():
   longitude = lonhash[state]
   offset_y =  int(((north - latitude) / (north - south)) * height)
   offset_x =  int(((west - longitude) / (west - east)) * width)
   radius = 2 * int(sizehash[state])
   draw.ellipse((offset_x, offset_y, (offset_x + radius), (offset_y + radius)), outline=0xff0000, fill=0x0000ff)
im.save("c:/ftp/cocc_py.jpg")
exit

 
