#!/usr/local/bin/ruby
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
filearray = Array.new
filearray = "mort96us.dat mort99us.dat mort02us.dat mort04us.dat".split
filearray.each do
  |file|
  text = File.open(file, "r")
  counter = 0; popcount = 0;
  text.each_line do
     |line|
     codesection = line[448,140] if (file == filearray.fetch(0))
     codesection = line[161,140] if (file == filearray.fetch(1))
     codesection = line[162,140] if (file == filearray.fetch(2))
     codesection = line[164,140] if (file == filearray.fetch(3))
     popcount = popcount +1
     counter = (counter + 1) if (codesection =~ /D57/i)
     end
  text.close
  rate = ((counter.to_f / popcount.to_f) * 100000).to_s[0,5]
  puts "\nRecords listing sickle cell is #{counter} in #{file} file"
  puts "Sickle cell rate per 100,000 records is #{rate} in #{file} file"
  end
exit 
