#!/usr/local/bin/perl
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
opendir(SEERDIR, "c\:\\big\\seer2006") || die ("Unable to open directory");
@files = readdir(SEERDIR);
closedir(SEERDIR);
chdir("c\:\\big\\seer2006");
foreach $datafile (@files)
{
next if ($datafile !~ /.txt/i);
open (TEXT, $datafile);
$line = " ";
while ($line ne "")
{
$line = <TEXT>;
$dx = substr($line, 47, 5);
$dx2 = substr($line, 52, 5);
next unless ($dx =~ /^905/ || $dx2 =~ /^905/);
$count++;
$place = substr($line,42,4);
if ($place =~ /C34[12389]/)
{
$place = "pleura";
}
elsif ($place =~ /C3[89][0123489]/)
{
$place = "pleura";
}
elsif ($place =~ /C48[28]/)
{
$place = "peritoneum";
}
elsif ($place =~ /C5[4567]/)
{
$place = "ovary";
}
elsif ($place =~ /C6[23]/)
{
$place = "testis";
}
else
{
next;
}
$dxp = "mesothelioma_" . $place;
unless (exists($dxhash{$dxp}))
{
$dxhash{$dxp} = "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0";
}
$age_at_dx = substr($line,24,3);
if ($age_at_dx > 95)
{
$age_at_dx = 95;
}
$age_at_dx = int($age_at_dx / 5);
@agearray = split(" ", $dxhash{$dxp});
$agearray[$age_at_dx]++;
$dxhash{$dxp} = join(" ", @agearray);
}
close TEXT;
}
while (($key, $value) = each(%dxhash))
{
@value_array = split(/ /, $value);
print "$key\|$value\n";
}
print "Total number of mesotheliomas is $count\n";
exit;
