#!/usr/local/bin/python
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
import os, re, string
count = 0
dxhash = {}
filelist = os.listdir("c:/big/seer2006")
os.chdir("c:/big/seer2006")
for file in filelist:
  infile = open(file,'r')
  for line in infile:
    code = line[47:52]
    code2 = line[52:57]
    meso_match = re.match(r'905', code)
    if not meso_match:
      meso_match = re.match(r'905', code2)
      if not meso_match:
        continue
    count = count + 1
    place = line[42:46]
    pleura_yes = re.match(r'C34[12389]', place)
    pleura_yes = re.match(r'C3[89][0123489]', place)
    peri_yes = re.match(r'C48[28]', place)
    ovi_yes = re.match(r'C5[4567]', place)
    test_yes = re.match(r'C6[23]', place)
    if pleura_yes:
      place = "pleura"
    elif pleura_yes:
      place = "pleura"
    elif peri_yes:
      place = "peritoneum"
    elif ovi_yes:
      place = "ovary"
    elif test_yes:
      place = "testis"
    else:
      continue
    dxp = "mesothelioma_" + place
    if not dxhash.has_key(dxp):
      dxhash[dxp] = "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0"
    age_at_dx = line[24:27]
    age_at_dx = int(age_at_dx)
    if (age_at_dx > 95):
       age_at_dx = 95
    age_at_dx = int(float(age_at_dx) / 5)
    agearray = dxhash[dxp].split(" ")
    agearray[age_at_dx] = str(int(agearray[age_at_dx]) + 1)
    dxhash[dxp] = " ".join(agearray)
keylist = dxhash.keys()
for item in keylist:
   print item + "|" + dxhash[item]
print "The total number of mesotheliomas is " + str(count)
exit

 
