#!/usr/local/bin/ruby
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
require 'mathn'
count = 0
dxhash = {}
filelist = Dir.glob("c:/big/seer2006/*.TXT")
filelist.each do
  |filepathname|
  seer_file = File.open(filepathname, "r")
  seer_file.each do
    |line|
    code1 = line.slice(47,5)
    code2 = line.slice(52,5)
    next unless (code1 =~ /^905/ || code2 =~ /^905/)
    count = count + 1
    place = line.slice(42,4)
    if place =~ /C34[12389]/
      place = "pleura"
    elsif place =~ /C3[89][0123489]/
      place = "pleura"
    elsif place =~ /C48[28]/
      place = "peritoneum"
    elsif place =~ /C5[4567]/
      place = "ovary"
    elsif place =~ /C6[23]/
      place = "testis"
    else
      next
    end
    dxp = "mesothelioma_" + place
    unless dxhash.has_key? dxp
      dxhash[dxp] = "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0"
    end
    age_at_dx = line.slice(24,3)
    next if age_at_dx !~ /[01][0-9]{2}/
    age_at_dx = age_at_dx.to_f
    if (age_at_dx > 95)
       age_at_dx = 95
    end
    age_at_dx = (age_at_dx.to_f / 5).to_i
    agearray = dxhash[dxp].split(" ")
    agearray[age_at_dx] = agearray[age_at_dx].to_i
    agearray[age_at_dx] = agearray[age_at_dx] + 1
    dxhash[dxp] = agearray.join(" ")
  end
end
dxhash.each{|key, value| puts key + "|" + value}
puts "The total number of mesotheliomas is " + count.to_s
exit

 
