#!/usr/local/bin/python
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
import os, re, string
census_in = open("c:/ftp/censuage.txt", "r")
total = {}
linearray = []
for line in census_in:
  linearray = line.split(",")
  age_at_dx = linearray[1]
  age_at_dx = re.sub(r'"', '', age_at_dx)
  age_at_dx = float(age_at_dx)
  if age_at_dx > 95:
    age_at_dx = 95
  age_at_dx = int(age_at_dx/5)
  if total.has_key(age_at_dx):
    total[age_at_dx] = total[age_at_dx] + int(linearray[2])
  else:
    total[age_at_dx] = int(linearray[2])
census_in.close()
f = open("c:\\ftp\\icdo3.txt", "r")
codehash = {}
subhash = {}
agearray = []
for line in f:
  linematch = re.search(r'([0-9]{4})\/([0-9]{1}) +(.+)$', line)
  if (linematch):
    icdcode = linematch.group(1) + linematch.group(2)
    term = string.rstrip(linematch.group(3))
    codehash[icdcode] = term
f.close()
filelist = os.listdir("c:/big/seer2006")
os.chdir("c:/big/seer2006")
for file in filelist:
  seer_file = open(file, "r")
  for line in seer_file:
    code1 = line[47:52]
    code2 = line[52:57]
    if codehash.has_key(code2):
      code1 = code2
    age_at_dx = int(line[24:27])
    if (age_at_dx > 95):
      age_at_dx = 95
    age_at_dx = int(float(age_at_dx)/5)
    if not subhash.has_key(code1):
      subhash[code1] = "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0"
    agearray = subhash[code1].split(" ")
    old_value = agearray[age_at_dx]
    new_value = int(old_value) + 1
    agearray[age_at_dx] = str(new_value)
    subhash[code1] = " ".join(agearray)
all_out = open("c:/ftp/seer_all.txt", "w")
adj_out = open("c:/ftp/seer_adj.txt", "w")
for key,value in subhash.iteritems():
  if codehash.has_key(key):
     value_array = value.split(" ")
     for i in range(len(value_array)):
       value_array[i] = str(int(float(value_array[i]) / float(total[i]) * 10000000))
     rate_value = " ".join(value_array)
     print>>all_out, codehash[key] + "\n" + value + "\n" + rate_value + "\n"
     print>>adj_out, codehash[key] + "|" + rate_value
exit

 
