#!/usr/local/bin/ruby
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
require 'mathn'
census_in = File.open("c:/ftp/censuage.txt", "r")
total = Hash.new(0)
dxhash = {}
linearray = []
total = Hash.new(0)
census_in.each do
  |line|
  linearray = line.split(",")
  age_at_dx = linearray[1]
  age_at_dx = age_at_dx.gsub(/\"/, "").to_i
  if age_at_dx > 95
    age_at_dx = 95;
  end
  age_at_dx = (age_at_dx.to_f / 5).to_i
  total[age_at_dx] = total[age_at_dx] + linearray[2].to_i
end
census_in.close
icd_in = File.open("c:/ftp/icdo3.txt", "r")
dictionary = {}
icd_in.each_line do
  |line|
  if line =~ /([0-9]{4})\/([0-9]{1}) +/
    code = $1 + $2
    term = $'
    term = term.sub(/ *\n/, "") if term =~ / *\n/
    dictionary[code] = term
  end
end
icd_in.close
all_out = File.open("c:/ftp/seer_all.txt", "w")
adj_out = File.open("c:/ftp/seer_adj.txt", "w")
filelist = Dir.glob("c:/big/seer2006/*.TXT")
filelist.each do
  |filepathname|
  seer_file = File.open(filepathname, "r")
  seer_file.each do
    |line|
    code1 = line.slice(47,5)
    code2 = line.slice(52,5)
    code1 = code2 if dictionary.has_key? code2
    unless dxhash.has_key? code1
      dxhash[code1] = "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0"
    end
    age_at_dx = line.slice(24,3)
    next if age_at_dx !~ /[01][0-9]{2}/
    age_at_dx = age_at_dx.to_f
    if (age_at_dx > 95)
       age_at_dx = 95
    end
    age_at_dx = (age_at_dx.to_f / 5).to_i
    agearray = dxhash[code1].split(" ")
    agearray[age_at_dx] = agearray[age_at_dx].to_i
    agearray[age_at_dx] = agearray[age_at_dx] + 1
    dxhash[code1] = agearray.join(" ")
  end
end
dxhash.each do
  |key, value|
  if dictionary.has_key?(key)
     value_array = value.split(" ")
     value_array.each_index do
       |i|
       value_array[i] = ((value_array[i].to_f / total[i].to_f) * 10000000).to_i
     end
     rate_value = value_array.join(" ")
     all_out.puts dictionary[key] + "\n" + value + "\n" + rate_value + "\n"
     adj_out.puts dictionary[key] + "|" + rate_value
  end
end
exit; 
