#!/usr/local/bin/perl
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
open (ICD, "c\:\\ftp\\icdo3\.txt");
$line = " ";
while ($line ne "")
{
$line = <ICD>;
if ($line =~ /([0-9]{4})\/([0-9]{1}) +/o)
{
$code = $1 . $2;
$term = $';
$term =~ s/ *\n//o;
$term = lc($term);
$dictionary{$code} = $term;
$agehash{$code} = "0 and 0";
}
}
close ICD;
opendir(FTPDIR, "C\:\\BIG\\SEER2006") || die ("Unable to open
directory");
@files = readdir(FTPDIR);
closedir(FTPDIR);
chdir("C\:\\SEER");
foreach $datafile (@files)
{
open (TEXT, $datafile);
$line = " ";
while ($line ne "")
{
$line = <TEXT>;
$code = substr($line, 47, 5);
$code2 = substr($line, 52, 5);
if (exists($dictionary{$code2}))
{
$code = $code2;
}
next if ((substr($line,42,3) ne "C53"));
$codecount{$code}++;
if (exists($dictionary{$code}))
{
$age = substr($line, 24, 3);
$oldcode = $agehash{$code};
$oldcode =~ / and /;
$oldage = $`;
$oldcount = $';
$newage = $oldage + $age;
$newcount = $oldcount + 1;
$agehash{$code} = $newage . " and " . $newcount;
}
}
}
while((my $key, my $value) = each (%agehash))
{
next if ($value eq "0 and 0");
next if ($codecount{$key} < 80);
$number = $codecount{$key};
$number = "000000" . $number;
$number = substr($number,-6,6);
$value =~ / and /;
$totalage = $`;
$count = $';
$average = int($totalage / $count);
$average = "00" . $average;
$average = substr($average,-3,3);
push(@outarray, "$average $number $dictionary{$key}");
}
print join("\n", (sort(@outarray)));
exit;
