#!/usr/local/bin/python
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
import sys, os, re, string
icd_file = open("c:\\ftp\\icdo3.txt", "r")
dictionary = {}
agehash = {}
codecount = {}
outarray = []
for line in icd_file:
    linematch = re.match(r'([0-9]{4})\/([0-9]{1})(.+)', line)
    if linematch:
      code = linematch.group(1) + linematch.group(2)
      term = linematch.group(3)
      term = re.sub(r' *\n', "", term)
      term = term.lower()
      term = term.lstrip()
      dictionary[code] = term
      agehash[code] = "0 and 0"
      codecount[code] = 0
icd_file.close()
filelist = os.listdir("c:\\big\\seer2006")
os.chdir("c:\\big\\seer2006")
for file in filelist:
  seer_file = open(file, "r")
  for line in seer_file:
      code = line[47:52]
      code2 = line[52:57]
      if (dictionary.has_key(code2)):
         code = code2
      if not line[42:45] == "C53":
         continue
      if dictionary.has_key(code):
         codecount[code] = codecount[code] + 1
         age = int(line[24:27])
         oldcode = agehash[code]
         oldcodematch = re.match(r'(.+) and (.+)', oldcode)
         if oldcodematch:
           oldage = oldcodematch.group(1)
           oldcount = oldcodematch.group(2)
         newage = int(oldage) + age
         newcount = int(oldcount) + 1
         agehash[code] = str(newage) + " and " + str(newcount)
  seer_file.close()
for key, value in agehash.iteritems():
   if (value == "0 and 0"):
     continue
   if (codecount[key] < 80):
     continue
   number = codecount[key]
   number = "000000" + str(number)
   number = number[-6:]
   valuematch = re.match(r'(.+) and (.+)', value)
   if valuematch:
     totalage = int(valuematch.group(1))
     count = int(valuematch.group(2))
   if (count > 0):
     average = int(float(totalage) / count)
     average = str(average)
     outarray.append(average + " " + number + " " + dictionary[key])
outarray = sorted(outarray)
for item in outarray:
  print item
exit

 
