#!/usr/local/bin/ruby
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
require 'mathn'
icd_file = File.open("c:/ftp/icdo3.txt", "r")
dictionary = {}; agehash = {}; codecount = {}; outarray = []
icd_file.each_line do
  |line|
  if (line =~ /([0-9]{4})\/([0-9]{1}) +/o)
    code = $1 + $2
    term = $'
    term.sub!(/ *\n/, "")
    term = term.downcase
    dictionary[code] = term
    agehash[code] = "0 and 0"
    codecount[code] = 0
  end
end
icd_file.close
filelist = Dir.glob("c:/big/seer2006/*.TXT")
filelist.each do
  |filepathname|
  seer_file = File.open(filepathname, "r")
  seer_file.each_line do
    |line|
    code = line.slice(47,5)
    code2 = line.slice(52,5)
    if (dictionary.has_key?(code2))
      code = code2
    end
    next unless (line.slice(42,3).eql?("C53"))
    if dictionary.has_key?(code)
       codecount[code] = codecount[code] + 1
       age = line.slice(24, 3).to_i
       oldcode = agehash[code]
       oldcode =~ / and /
       oldage = $`.to_i
       oldcount = $'.to_i
       newage = oldage + age
       newcount = oldcount + 1
       agehash[code] = newage.to_s + " and " + newcount.to_s
     end
  end
  seer_file.close
end
agehash.each_pair do
   |key, value|
   next if (value.eql?("0 and 0"))
   next if (codecount[key] < 80)
   number = codecount[key]
   number = "000000" + number.to_s
   number = number.slice(-6,6)
   value =~ / and /
   totalage = $`.to_i
   count = $'.to_i
   if (count > 0)
     average = (totalage / count).to_f
     average = average.floor.to_s
     outarray.push(average + " " + number + " " + dictionary[key])
   end
end
puts outarray.sort.join("\n")
exit

 
