#!/usr/local/bin/ruby
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
require 'RMagick'
north = 49.to_f     #degrees latitude
south = 25.to_f     #degrees latitude
west = 125.to_f     #degrees longitude
east = 66.to_f      #degrees longitude
#corresponds to the us continental extremities
text = File.open("c\:\\ftp\\loc_states.txt", "r")
lathash = Hash.new
lonhash = Hash.new
text.each do
    |line|
    line =~ /^([A-Z]{2})\,([0-9\.]+)\,\-?([\.0-9]+) *$/
    state = $1
    latitude = $2
    longitude = $3
    lathash[state] = latitude.to_f
    lonhash[state] = longitude.to_f
end
text.close
imgl = Magick::ImageList.new("c\:\\ftp\\us\.gif")
width = imgl.columns
height = imgl.rows
gc = Magick::Draw.new
lathash.each do
   |key,value|
   state = key
   latitude = value.to_f
   longitude = lonhash[key].to_f
   offset_y =  (((north - latitude) / (north - south)) * height).ceil
   offset_x =  (((west - longitude) / (west - east)) * width).ceil
   gc.fill_opacity(0)
   gc.stroke('red').stroke_width(1)
   gc.circle(offset_x, offset_y, (offset_x - 15), (offset_y))
   gc.fill('black')
   gc.stroke('transparent')
   gc.text((offset_x - 5), (offset_y + 5), state)
   gc.draw(imgl)
end
imgl.border!(1,1, 'lightcyan2')
imgl.write("us_out.gif")
exit

 
