#!/usr/local/bin/perl
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
open (STOPFILE, "stop.txt");
undef($/);
@stoparray = split(/\n/, <STOPFILE>);
$/ = "\n";
open (TEXT, "cancer_gene_titles.txt");
open (OUT, ">phrases.txt");
$sentence = " ";
while ($sentence ne "")
{
$sentence = <TEXT>;
$sentence =~ s/\n$/ /;
foreach $stopword (@stoparray)
{
$sentence =~ s/ *\b$stopword\b */\n/g;
}
push(@phrasearray, (split(/\n/, $sentence)));
}
%stophash = map{$_, ""} @phrasearray;
@phrasearray = sort(keys(%stophash));
print OUT join("\n",@phrasearray);
exit;
