#!/usr/local/bin/perl
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
open (STOPFILE, "stop.txt");
open (OUT, ">index.out");
undef($/);
@stoparray = split(/\n/, <STOPFILE>);
open (TEXT, "text.txt");
$textfile = <TEXT>;
$textfile =~ s/\n/ /g;
@sentencearray = split(/[\.\!\?] +(?=[A-Z])/, $textfile);
for ($i=0;$i<(scalar(@sentencearray));$i++)
{
$location = $i + 1;
$sentence = lc($sentencearray[$i]);
$sentence =~ s/\'s//;
$sentence =~ tr/\000-\011\013-\014\016-\037\041-\055\173-\377//d;
$sentence =~ s/^ +//;
$sentence =~ s/ +$//;
$sentence =~ s/ +/ /;
foreach $stopword (@stoparray)
{
$sentence =~ s/\b$stopword\b/\*/g;
}
@phrasearray = split(/ *\* */, $sentence);
foreach $phrase (@phrasearray)
{
if (exists($phrasehash{$phrase}))
{
$phrasehash{$phrase} = $phrasehash{$phrase} . "," . $location;
}
else
{
next if ($phrase eq "");
next if ($phrase =~ /^[^a-z]/);
$phrasehash{$phrase} = $location;
}
}
}
foreach $key (sort(keys(%phrasehash)))
{
print OUT "$key $phrasehash{$key}\n";
}
exit;
