#!/usr/local/bin/ruby
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
phrase_array = []
phrasehash = {}
stoparray = IO.read("stop.txt").split(/\n/)
text = IO.read("text.txt")
text.gsub!(/\n+/," ") if text.include? "\n"
sentence_array = text.split(/[\.\!\?] +(?=[A-Z])/)
sentence_array.each do
 |sentence|
 count = sentence_array.rindex(sentence) + 1
 sentence = sentence.downcase.tr('^a-z0-9 ',' ').strip.gsub(/ +/," ")
 stoparray.each do
   |stopword|
   stopword = stopword.chomp
   sentence.gsub!(/ *\b#{stopword}\b */, "\n") if sentence.include? stopword
   end
 sentence.split(/\n/).each do
   |phrase|
   next if phrase == ""
   next if phrase =~ /^[^a-z]/
   if phrasehash.has_key?(phrase)
     phrasehash[phrase]= "#{phrasehash[phrase]}\, #{count}"
   else
     phrasehash[phrase] = count
   end
 end
end
phrasehash.keys.sort.each {|key| puts "#{key} #{phrasehash[key]}"}
exit

 
