#!/usr/local/bin/python
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
import re
import string
from math import sqrt
from math import pow
treasure = {}
paradise = {}
filelist = ["treasure.txt", "paradise.txt"]
stopfile = open("stop.txt",'r')
stop_list = stopfile.readlines()
stopfile.close()
phraseform = re.compile(r'^[a-z]+ [a-z ]+$')
for filename in filelist:
   in_text = open(filename, "r")
   in_text_string = in_text.read()
   in_text.close()
   in_text_string = in_text_string.replace("\n"," ")
   for stopword in stop_list:
     stopword = string.rstrip(stopword)
     in_text_string = re.sub(r' *\b' + stopword + r'\b *', '\n',in_text_string)
   in_text_string = re.sub(r'[\,\:\;\(\)]','\n',in_text_string)
   in_text_string = re.sub(r'[\.\!\?] +(?=[A-Z])', '\n', in_text_string)
   in_text_string = string.lower(in_text_string)
   item_list = re.split(r' *\n *', in_text_string)
   for phrase in item_list:
       phrase = re.sub(r' +',' ', phrase)
       phrase = string.strip(phrase)
       phrasematch = phraseform.match(phrase)
       if not (phrasematch):
          continue
       if (filename == "paradise.txt"):
         if paradise.has_key(phrase):
           paradise[phrase] = paradise[phrase] + 1
         else:
           paradise[phrase] = 1
         if not (treasure.has_key(phrase)):
           treasure[phrase] = 0 
       if (filename == "treasure.txt"):
         if treasure.has_key(phrase):
           treasure[phrase] = treasure[phrase] + 1
         else:
           treasure[phrase] = 1
         if not (paradise.has_key(phrase)):
           paradise[phrase] = 0
count = 0; sumtally1 = 0; sumtally2 = 0; sqtally1 = 0; sqtally2 = 0
prodtally12 = 0; part1 = 0; part2 = 0; part3 = 0;
keylist = paradise.keys()
for key in keylist:
  count = count + 1;
  sumtally1 = sumtally1 + paradise[key]
  sumtally2 = sumtally2 + treasure[key]
  sqtally1 = sqtally1 + pow(paradise[key],2)
  sqtally2 = sqtally2 + pow(treasure[key],2)
  prodtally12 = prodtally12 + (paradise[key] * treasure[key])
part1 = prodtally12 - (float(sumtally1 * sumtally2) / count)
part2 = sqtally1 -  (float(pow(sumtally1,2)) / count)
part3 = sqtally2 -  (float(pow(sumtally2,2)) / count)
similarity12 = float(part1) / float(sqrt(part2 * part3))
print "The Pearson score is", similarity12 
exit

 
