#!/usr/local/bin/ruby
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
require 'mathn'
treasure = {}; paradise = {};
filelist = ["treasure.txt", "paradise.txt"]
filelist.each do
  |filename|
  stoparray = IO.read("stop.txt").split(/\n/)
  text = IO.read(filename)
  text.gsub!("\n"," ") if text.include? "\n"
  stoparray.each do
    |stopword|
    stopword = stopword.chomp
    text.gsub!(/ *\b#{stopword}\b */, "\n") if text.include? stopword
    text.gsub!(/[\,\:\;\(\)]/, "\n") if text =~ /[\,\:\;\(\)]/
    end
  text.gsub!(/[\.\!\?] +(?=[A-Z])/, "\n") if text =~ /[\.\!\?] +(?=[A-Z])/
  text.downcase.strip.split(/ *\n */).each do
    |phrase|
    phrase.gsub!(/ +/," ") if phrase =~ / +/
    phrase.strip!
    next if phrase !~ /^[a-z]+ [a-z ]+$/
    if filename == "paradise.txt"
      if paradise.has_key?(phrase)
        paradise[phrase] = paradise[phrase] + 1
      else
        paradise[phrase] = 1
      end
      treasure[phrase] = 0 unless treasure.has_key?(phrase)
    end
    if filename == "treasure.txt"
      if treasure.has_key?(phrase)
        treasure[phrase] = treasure[phrase] + 1
      else
        treasure[phrase] = 1
      end
      paradise[phrase] = 0 unless paradise.has_key?(phrase)
    end
  end
end
count = 0; sumtally1 = 0; sumtally2 = 0; sqtally1 = 0; sqtally2 = 0
prodtally12 = 0; part1 = 0; part2 = 0; part3 = 0;
paradise.each do
  |k,v|
  count = count + 1;
  sumtally1 = sumtally1 + v
  sumtally2 = sumtally2 + treasure[k]
  sqtally1 = sqtally1 + v**2;
  sqtally2 = sqtally2 + treasure[k]**2
  prodtally12 = prodtally12 + (v * treasure[k])
end
part1 = prodtally12 - ((sumtally1 * sumtally2).to_f / count.to_f)
part2 = sqtally1 -  (((sumtally1)**2).to_f / count.to_f)
part3 = sqtally2 -  (((sumtally2)**2).to_f / count.to_f)
similarity12 = part1.to_f / (Math.sqrt(part2 * part3)).to_f
puts "The Pearson score is #{similarity12}" 
exit

 
