#!/usr/local/bin/perl
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
open(MESH, "C\:\\BIG\\D2009.BIN");
open(OUT, ">mesh.out");
$line = " ";
while ($line ne "")
{
$line = <MESH>;
$name = $1 if ($line =~ /MH = (.+)$/);
if ($line =~ /MN = (.+)$/)
{
$number = $1;
$numberhash{$number} = $name;
if (exists($namehash{$name}))
{
$namehash{$name} = $namehash{$name} . " " . $number;
}
else
{
$namehash{$name} = $number;
}
}
}
close(MESH);
while((my $key, my $value) = each (%namehash))
{
print OUT "\nTERM LINEAGE FOR " . uc($key) . "\n";
my @valuelist = split(/ /,$value);
my @cumlist;
my %marked;
foreach $meshno (@valuelist)
{
push(@cumlist, $meshno);
while ($meshno =~ /\.[0-9]+$/)
{
$meshno = $`;
push(@cumlist, $meshno);
}
}
@cumlist = grep { $marked{$_}++; $marked{$_} == 1; }@cumlist;
@cumlist = reverse(sort(@cumlist));
foreach my $thing (@cumlist)
{
print OUT "$thing $numberhash{$thing}\n";
}
}
exit;
