#!/usr/local/bin/python
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
import re
import string
mesh = open('C:\\big\\d2009.bin', "r")
out = open("mesh.out", "w")
namehash = {}
numberhash = {}
for line in mesh:
  namematch = re.search(r'MH = (.+)$', line)
  if (namematch):
    name = namematch.group(1)
  numbermatch = re.search(r'MN = (.+)$',line)
  if numbermatch:
     number = numbermatch.group(1)
     numberhash[str(number)] = name
     if namehash.has_key(name):
        namehash[name] = namehash[name] + ' ' + str(number)
     else:
        namehash[name] = str(number)
mesh.close()
keylist = namehash.keys()
keylist.sort()
for key in keylist:
   print>>out,"\nTERM LINEAGE FOR ", key.upper()
   cumlist = []
   item_list = namehash[key].split(" ")
   for phrase in item_list:
       cumlist.append(phrase)
       while re.search(r'\.', phrase):
         phrase = re.sub(r'\.[0-9]+$',"", phrase)
         cumlist.append(phrase)
   U = []
   for item in cumlist:
       if item not in U:
           U.append(item)
   U.sort()
   for thing in U:
       print>>out, thing, numberhash[str(thing)]
exit 
