#!/usr/local/bin/ruby
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
mesh = File.open("c\:\\big\\d2009.bin", "r")
out = open("mesh.out", "w")
namehash = Hash.new("")
numberhash = Hash.new("")
name = ""
number = ""
mesh.each_line do
  |line|
  if (line =~ /MH \= (.+)$/)
    name = $1
  end
  if (line =~ /MN \= (.+)$/)
     number = $1
     numberhash[number] = name
     if namehash.has_key?(name)
       namehash[name] = namehash[name] + " " + number
     else
       namehash[name] = number
     end
   end
end
mesh.close
namehash.keys.sort.each do
  |k|
  out.puts "\nTERM LINEAGE FOR " + k
  cumlist = []
  item_list = namehash[k].split(" ")
  item_list.each do
    |phrase|
    cumlist.push(phrase)
    while (phrase =~ /\.[0-9]+$/)
       phrase = $`
       cumlist.push(phrase)
    end
  end
  cumlist.sort.uniq.each {|it| out.puts it + " " + numberhash[it]}
end
exit

 
