#!/usr/local/bin/python
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
from pysqlite2 import dbapi2 as sqlite
import string, re, os
mesh_file = open('C:\\big\\d2009.bin', "r")
mesh_hash = {}
entry = ()
for line in mesh_file:
  namematch = re.search(r'^MH = (.+)$', line)
  if (namematch):
    name = namematch.group(1)
  numbermatch = re.search(r'^MN = (.+)$',line)
  if numbermatch:
     number = numbermatch.group(1)
     mesh_hash[str(number)] = name
con=sqlite.connect('test1.db')
cur=con.cursor()
cur.executescript("""
    create table mesh
    (
      name           varchar(64),
      term           varchar(64)
    );
    """)
for key, value in mesh_hash.iteritems():  
  entry = (key, value)
  cur.execute("insert into mesh (name, term) values (?, ?)", entry)
con.commit()
exit 
