#!/usr/local/bin/perl
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
open (ICD, "c\:\\ftp\\icdo3\.txt");
$line = " ";
while ($line ne "")
{
$line = <ICD>;
if ($line =~ /([0-9]{4})\/([0-9]{1}) +/o)
{
$code = $1 . $2;
$term = $';
$term =~ s/ *\n//o;
$term = lc($term);
$dictionary{$code} = $term;
}
}
close ICD;
opendir(SEERDIR, "c\:\\seer") || die ("Unable to open directory");
@files = readdir(SEERDIR);
closedir(SEERDIR);
open (OUT, ">c\:\\ftp\\seerdist.txt");
chdir("c\:\\seer");
foreach $datafile (@files)
{
next if ($datafile !~ /.txt/i);
open (TEXT, $datafile);
$line = " ";
while ($line ne "")
{
$line = <TEXT>;
$dx = substr($line, 47, 5);
$dx2 = substr($line, 52, 5);
if (exists($dictionary{$dx2}))
{
$dx = $dx2;
}
$dxhash{$dx}++;
}
close TEXT;
}
while (($key, $value) = each(%dxhash))
{
if (exists($dictionary{$key}))
{
$value = "0000000" . $value;
$value = substr($value, -7, 7);
push(@distarray, "$value $dictionary{$key}");
}
}
print join("\n", reverse(sort(@distarray)));
exit;
