#!/usr/local/bin/ruby
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
f = File.open("c:/ftp/icdo3.txt")
fout = File.open("SEER.OUT", "w")
codehash = Hash.new("")
subhash = Hash.new(0)
f.each do
  |line|
  next unless (line =~ /([0-9]{4})\/([0-9]{1}) +/)
  icdcode = $1 << $2
  term = $'.chomp!
  codehash[icdcode] = term
end
f.close
filelist = Dir.glob("c:/seer/*.TXT")
begin_time = Time.new.to_f
filelist.each do
  |filepathname|
  seer_file = File.open(filepathname)
  seer_file.each do
    |line|
    code1 = line.slice(47,5)
    code2 = line.slice(52,5)
    code1 = code2 if codehash.has_key? code2
    subhash[code1] = subhash[code1] + 1
  end
end
subhash.each do
   |key,value|
   if codehash.has_key?(key)
     fout.printf("%-7.07d %-s \n", value, codehash[key])
   end
end
fout.close
fout = File.open("SEER.OUT")
final = File.open("seer2.out","w")
final.puts(fout.readlines.sort.reverse.join)
puts "\nTime to parse SEER files - #{Time.new.to_f - begin_time} seconds"
exit

 
