#!/usr/local/bin/python
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
import os, re, string
f = open("c:\\ftp\\icdo3.txt", "r")
fout = open("SEER.OUT", "w")
codehash = {}
subhash = {}
agearray = []
for line in f:
  linematch = re.search(r'([0-9]{4})\/([0-9]{1}) +(.+)$', line)
  if (linematch):
    icdcode = linematch.group(1) + linematch.group(2)
    term = string.rstrip(linematch.group(3))
    codehash[icdcode] = term
f.close()
filelist = os.listdir("c:\\seer")
os.chdir("c:\\seer")
for file in filelist:
  seer_file = open(file, "r")
  for line in seer_file:
    code1 = line[47:52]
    code2 = line[52:57]
    if codehash.has_key(code2):
      code1 = code2
    age_at_dx = int(line[24:27])
    if (age_at_dx > 95):
      age_at_dx = 95
    age_at_dx = int(age_at_dx/5)
    if not subhash.has_key(code1):
      subhash[code1] = "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0"
    agearray = subhash[code1].split(" ")
    old_value = agearray[age_at_dx]
    new_value = int(old_value) + 1
    agearray[age_at_dx] = str(new_value)
    subhash[code1] = " ".join(agearray)
keylist = subhash.keys()
for item in keylist:
  if codehash.has_key(item):
    print>>fout, codehash[item] + "|" + subhash[item]
fout.close()
orderfile = open("c:\\ftp\\py\\SEER.OUT", "r")
line_array = orderfile.readlines()
line_array.sort()
for item in line_array:
  print item,
exit 
