#!/usr/local/bin/ruby
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
f = File.open("c:/ftp/icdo3.txt")
dxhash = Hash.new("")
codehash = Hash.new("")
distarray = []
fout = File.open("SEER.OUT", "w")
f.each do
  |line|
  next unless (line =~ /([0-9]{4})\/([0-9]{1}) +/)
  icdcode = $1 << $2
  term = $'.chomp!
  codehash[icdcode] = term
end
f.close
filelist = Dir.glob("c:/seer/*.TXT")
filelist.each do
  |filepathname|
  seer_file = File.open(filepathname, "r")
  seer_file.each do
    |line|
    code1 = line.slice(47,5)
    code2 = line.slice(52,5)
    code1 = code2 if codehash.has_key? code2
    unless dxhash.has_key? code1
      dxhash[code1] = "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0"
    end
    age_at_dx = line.slice(24,3)
    next if age_at_dx !~ /[01][0-9]{2}/
    age_at_dx = age_at_dx.to_f
    if (age_at_dx > 95)
       age_at_dx = 95
    end
    age_at_dx = (age_at_dx / 5).to_i
    agearray = dxhash[code1].split(" ")
    agearray[age_at_dx] = agearray[age_at_dx].to_i
    agearray[age_at_dx] = agearray[age_at_dx] + 1
    dxhash[code1] = agearray.join(" ")
  end
end
dxhash.each do
  |key, value|
  if codehash.has_key? key
     distarray.push("#{codehash[key]}\|#{value}")
  end
end
print distarray.sort.join("\n")
exit 
