#!/usr/local/bin/ruby
#
#This Perl script was created by Jules J. Berman, and is 
#distributed as a supplemental resource for his book,
#Methods in Medical Informatics: Fundamentals of Healthcare 
#Programming in Perl, Python, and Ruby, published in September,
#2010, by the CRC Press 
#
#This software is distributed under the GNU General Public License
#http://www.gnu.org/licenses/gpl.html
#
#The software is provided "as is", without warranty of any kind,
#express or implied, including but not limited to the warranties
#of merchantability, fitness for a particular purpose and
#noninfringement. in no event shall the authors or copyright
#holders be liable for any claim, damages or other liability,
#whether in an action of contract, tort or otherwise, arising
#from, out of or in connection with the software or the use or
#other dealings in the software.
#
$/ = "PMID- "
in_text = File.open("c:/big/cancer_gene_pubmed.txt", "r")
out_text = File.open("cancer_gene_titles.txt", "w")
in_text.each_line do
  |line|
  if (line =~ /\nTI  \-(.+)\n[A-Z]{2}  \-/)
    title = $1.downcase
    title.gsub!(/\'s/, "") if title =~ /\'s/
    title.gsub!(/\W/, " ") if title =~ /\W/
    title.gsub!(/omas/, "oma") if title =~ /omas/
    title.gsub!(/tumour/, "tumor") if title =~ /tumour/
    title.gsub!(/\n/, " ") if title =~ /\n/
    title = title.strip
    title.gsub!(/ +/, " ") if title =~ / +/
    next if (title !~ /[a-z]+/)
    out_text.puts title
  end
end
exit 
